ghc-8.0.2: The GHC API

Safe Haskell | None
Language | Haskell2010

PipelineMonad

Description

The CompPipeline monad and associated ops

Defined in separate module so that it can safely be imported from Hooks

# Documentation

newtype CompPipeline a Source #

Constructors

P |
Fields unP :: PipeEnv -> PipeState -> IO (PipeState, a)

Instances

Monad CompPipeline # |
Methods (>>=) :: CompPipeline a -> (a -> CompPipeline b) -> CompPipeline b Source # (>>) :: CompPipeline a -> CompPipeline b -> CompPipeline b Source # return :: a -> CompPipeline a Source # fail :: String -> CompPipeline a Source #
Functor CompPipeline # |
Methods fmap :: (a -> b) -> CompPipeline a -> CompPipeline b Source # (<$) :: a -> CompPipeline b -> CompPipeline a Source #
Applicative CompPipeline # |
Methods pure :: a -> CompPipeline a Source # (<*>) :: CompPipeline (a -> b) -> CompPipeline a -> CompPipeline b Source # (*>) :: CompPipeline a -> CompPipeline b -> CompPipeline b Source # (<*) :: CompPipeline a -> CompPipeline b -> CompPipeline a Source #
MonadIO CompPipeline # |
Methods liftIO :: IO a -> CompPipeline a Source #
HasDynFlags CompPipeline # |
Methods getDynFlags :: CompPipeline DynFlags Source #

evalP :: CompPipeline a -> PipeEnv -> PipeState -> IO a Source #

data PhasePlus Source #

Constructors

RealPhase Phase |
HscOut HscSource ModuleName HscStatus |

Instances

Outputable PhasePlus # |
Methods ppr :: PhasePlus -> SDoc Source # pprPrec :: Rational -> PhasePlus -> SDoc Source #

data PipeEnv Source #

Constructors

PipeEnv |
Fields stop_phase :: Phase Stop just before this phase src_filename :: String basename of original input source src_basename :: String basename of original input source src_suffix :: String its extension output_spec :: PipelineOutput says where to put the pipeline output

data PipeState Source #

Constructors

PipeState |
Fields hsc_env :: HscEnv only the DynFlags change in the HscEnv. The DynFlags change at various points, for example when we read the OPTIONS_GHC pragmas in the Cpp phase. maybe_loc :: Maybe ModLocation the ModLocation. This is discovered during compilation, in the Hsc phase where we read the module header. maybe_stub_o :: Maybe FilePath the stub object. This is set by the Hsc phase if a stub object was created. The stub object will be joined with the main compilation object using "ld -r" at the end.

data PipelineOutput Source #

Constructors

Temporary | Output should be to a temporary file: we're going to run more compilation steps on this output later.
Persistent | We want a persistent file, i.e. a file in the current directory derived from the input filename, but with the appropriate extension. eg. in "ghc -c Foo.hs" the output goes into ./Foo.o.
SpecificFile | The output must go into the specific outputFile in DynFlags. We don't store the filename in the constructor as it changes when doing -dynamic-too.

Instances

Show PipelineOutput # |
Methods showsPrec :: Int -> PipelineOutput -> ShowS Source # show :: PipelineOutput -> String Source # showList :: [PipelineOutput] -> ShowS Source #

getPipeEnv :: CompPipeline PipeEnv Source #

getPipeState :: CompPipeline PipeState Source #

setDynFlags :: DynFlags -> CompPipeline () Source #

setModLocation :: ModLocation -> CompPipeline () Source #

setStubO :: FilePath -> CompPipeline () Source #